﻿(function () {
    "use strict"

    angular.module('starter')
    .controller('account', ['$rootScope', '$scope', '$timeout', '$ionicPopup', 'nav', 'localStorage', 'iosHelper', 'validate', 'const', function ($rootScope, $scope, $timeout, $ionicPopup, nav, localStorage, iosHelper, validate, constants) {
        $scope.btnText = '获取验证码';
        $scope.user = { name: '', password: '' };
        $scope.userRegistInfo = { phoneNum: '', verifyCode: '', password: '', again: '' };
        $scope.resetPasswordInfo = { phoneNum: '', verifyCode: '', password: '', again: '' };
        $scope.modifyPasswordInfo = { oldPwd: '', newPwd: '', again: '' };

        var userInfo = localStorage.getObject('userInfo',userInfo);
        $scope.userName = userInfo.userName;
        $scope.rpcStatus = userInfo.rpcStatus;

        var showPopup = function (msg) {
            var msgPopup = $ionicPopup.show({
                subTitle: msg
            });
            
            $timeout(function () {
                msgPopup.close();
            }, 1000);
        }

        var showConfirm = function (msg, confirmFunc, cancelFunc) {
            var confirmPopup = $ionicPopup.confirm({
                subTitle: msg
            });
            confirmPopup.then(function (res) {
                if (res) {
                    confirmFunc();
                } else {
                    cancelFunc();
                }
            });
        };

        $scope.userRegist = function () {
            var registInfo = $scope.userRegistInfo;
            if (validate.nullOrEmpty(registInfo.verifyCode)) {
                showPopup('注册信息不能为空');
                return;
            };

            if (validate.mobile(registInfo.phoneNum) && validate.password(registInfo.password) && validate.password(registInfo.again)) {
                var params = [registInfo.phoneNum, registInfo.verifyCode, registInfo.password, registInfo.again];

                var successFunc = function (result) {
                    //$scope.$apply(function () {
                    //    nav.navigate('tab/certOption');
                    //});
                    alert(result);
                }

                var failFunc = function (error) {
                    alert("Error: \r\n" + error);
                };

                iosHelper.userRegist({ data: params, success: successFunc, fail: failFunc });
            }
            else {
                showPopup('请输入正确的信息格式');
                return;
            }
        };

        $scope.login = function () {
            if (validate.mobile($scope.user.name) && validate.password($scope.user.password)) {
                var params = [$scope.user.name, $scope.user.password];

                var successFunc = function (result) {
                    //$scope.$apply(function () {
                    //    nav.navigate('tab/certOption');
                    //});
                    alert(result);
                }

                var failFunc = function (error) {
                    alert("Error: \r\n" + error);
                };

                iosHelper.login({ data: params, success: successFunc, fail: failFunc });
            }
            else {
                showPopup('请输入正确的手机号码和密码');
                return;
            }
        };

        $scope.signOut = function () {
            var confirm = function () {
               localStorage.setObject('userInfo','');
                nav.navigate('login');
            };
            var cancel = function () {  };

            showConfirm('是否退出账户', confirm, cancel);
        };

        $scope.modifyUserPwd = function () {
            var modifyInfo = $scope.modifyPasswordInfo;
            if (validate.password(modifyInfo.oldPwd) && validate.password(modifyInfo.newPwd) && validate.password(modifyInfo.again)) {
                var params = [modifyInfo.oldPwd, modifyInfo.newPwd, modifyInfo.again];

                var successFunc = function (result) {
                    //$scope.$apply(function () {
                    //    nav.navigate('tab/certOption');
                    //});
                    alert(result);
                }

                var failFunc = function (error) {
                    alert("Error: \r\n" + error);
                };

                iosHelper.modifyUserPwd({ data: params, success: successFunc, fail: failFunc });
            }
            else {
                showPopup('请输入正确的信息格式');
                return;
            }
        };

        $scope.resetUserPwd = function () {
            var resetInfo = $scope.resetPasswordInfo;
            if (validate.nullOrEmpty(resetInfo.verifyCode)) {
                showPopup('验证码不能为空');
                return;
            };

            if (validate.mobile(resetInfo.phoneNum) && validate.password(resetInfo.password) && validate.password(resetInfo.again)) {
                var params = [resetInfo.phoneNum, resetInfo.verifyCode, resetInfo.password, resetInfo.again];

                var successFunc = function (result) {
                    //$scope.$apply(function () {
                    //    nav.navigate('tab/certOption');
                    //});
                    alert(result);
                }

                var failFunc = function (error) {
                    alert("Error: \r\n" + error);
                };

                iosHelper.resetUserPwd({ data: params, success: successFunc, fail: failFunc });
            }
            else {
                showPopup('请输入正确的信息格式');
                return;
            }
        };

        $scope.getVerifyCode = function (phoneNum) {
            var params = [phoneNum];
            var successFunc = function (result) {
                //$scope.$apply(function () {
                //    nav.navigate('tab/certOption');
                //});
                alert(result);
            }

            var failFunc = function (error) {
                alert("Error: \r\n" + error);
            };
            iosHelper.getVerifyCode({ data: params, success: successFunc, fail: failFunc });
        };

        $scope.navToRpcView = function (phoneNum) {
            var params = [];
            var successFunc = function (result) {
//                $scope.$apply(function () {
//                    nav.navigate('tab/certOption');
//                });
                alert(result);
            }

            var failFunc = function (error) {
                alert("Error: \r\n" + error);
            };

            iosHelper.navToRpcView({ data: params, success: successFunc, fail: failFunc });
        };

        $scope.navToPrivateView = function (phoneNum) {
            var params = [];
            var successFunc = function (result) {

            }

            var failFunc = function (error) {
                alert("Error: \r\n" + error);
            };

            iosHelper.navToPrivateView({ data: params, success: successFunc, fail: failFunc });
        };

        $scope.navigate = function (state) {
            nav.navigate(state);
        };

        
    }]);
})();