﻿(function () {
    //"use strict"

    angular.module('starter')
    .factory('iosHelper', [function () {
        var accountCaller = function (method, parameter, success, fail) {
            return Cordova.exec(success, fail, "accountPlugin", method, parameter);
        };

        var faceRecognitionCaller = function (method, parameter, success, fail) {
            return Cordova.exec(success, fail, "GeRenZiliao", method, parameter);
        };

        //用户注册
        var userRegist = function (options) {
            accountCaller("userRegist", options.data, options.success, options.fail);
        };

        //用户登录
        var login = function (options) {
            faceRecognitionCaller("login", options.data, options.success, options.fail);
        };

        //修改登录密码
        var modifyUserPwd =function (options) {
            accountCaller("modifyUserPwd", options.data, options.success, options.fail);
        }; 

        //忘记登录密码
        var resetUserPwd = function (options) {
            accountCaller("resetUserPwd", options.data, options.success, options.fail);
        };

        //获取验证码
        var getVerifyCode = function (options) {
            accountCaller("getVerifyCode", options.data, options.success, options.fail);
        };

        //显示扫一扫页面
        var navToScanView = function (options) {
            faceRecognitionCaller("navToScanView", options.data, options.success, options.fail);
        };

        //显示实人认证页面
        var navToRpcView = function (options) {
            faceRecognitionCaller("navToRpcView", options.data, options.success, options.fail);
        };

        //显示个人信息页面
        var navToPrivateView = function (options) {
            faceRecognitionCaller("navToPrivateView", options.data, options.success, options.fail);
        };

        //获取加密后的字符串(用于签署)
        var getCipherText = function (options) {
            faceRecognitionCaller("getCipherText", options.data, options.success, options.fail);
        };

        return {
            userRegist: userRegist, 
            login: login, 
            modifyUserPwd: modifyUserPwd,
            resetUserPwd: resetUserPwd,
            getVerifyCode: getVerifyCode,

            navToPrivateView: navToPrivateView,
            navToRpcView: navToRpcView,
            getCipherText: getCipherText,
            navToScanView:navToScanView
        };
    }]);
})();