﻿(function () {
    "use strict"

    angular.module('starter')
    .factory('request', ['$http', '$location', '$rootScope', 'windowLocationReload', function ($http, $location, $rootScope, windowLocationReload) {
        var postFunc = function (req) {
            req.data = req.data || {};

            $http({
                method: 'POST',
                params: req.params,
                url: req.url,
                data: req.data,
                //headers: { 'Content-Type': 'application/x-www-form-urlencoded', 'X-Requested-With': 'XMLHttpRequest', 'RequestVerificationToken': requestVerificationToken },
                headers: { 'Content-Type': 'application/x-www-form-urlencoded', 'X-Requested-With': 'XMLHttpRequest'},
                transformRequest: function (obj) {
                    var str = [];
                    for (var p in obj) {
                        if (angular.isArray(obj[p])) {
                            obj[p].forEach(function (o) {
                                str.push(encodeURIComponent(p) + "=" + encodeURIComponent(o));
                            });
                        }
                        else {
                            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                        }
                    }
                    return str.join("&");
                }
            })
            .success(function (data, status, headers, config) {
                req.success(data, status, headers, config);
            })
            .error(function (data, status, headers, config) {
                req.error(data, status, headers, config);
            });
        };

        var getFunc = function (req) {
            req.data = req.data || {};

            $http({
                method: 'GET',
                //params: angular.extend({}, req.params, {__RequestVerificationToken: $rootScope.antiforgeryToken}),
                params: req.params,
                url: req.url,
                data: req.data
            })
            .success(function (data, status, headers, config) {
                req.success(data, status, headers, config);
            })
            .error(function (data, status, headers, config) {
                req.error(data, status, headers, config);
            });
        };

        var uploadFunc = function (req) {
            req.data = req.data || {};
            var fd = new FormData();
            angular.forEach(req.data, function (value, key) {
                fd.append(key, value);
            });

            $http({
                method: 'POST',
                params: req.params,
                url: req.url,
                data: fd,
                //headers: { 'Content-Type': undefined, 'X-Requested-With': 'XMLHttpRequest', 'RequestVerificationToken': requestVerificationToken },
                headers: { 'Content-Type': 'application/x-www-form-urlencoded'},
                transformRequest: function (data) { return data; }
            })
            .success(function (data, status, headers, config) {
                req.success(data, status, headers, config);
            })
            .error(function (data, status, headers, config) {
                req.error(data, status, headers, config);
            });
        };

        return {
            post: postFunc,
            get: getFunc,
            upload: uploadFunc
        };
    }]);
})();