﻿(function () {
    "use strict"

    angular.module('starter')
    .factory('url', [function () {
        var resxUrlGen = function (type) {
            return function (code) {
                if (code.indexOf('zh') == 0)
                    return '/Content/site/json/' + type + '.zh-CHS.json';
                else if (code.indexOf('ja') == 0)
                    return '/Content/site/json/' + type + '.ja.json';
                else
                    return '/Content/site/json/' + type + '.json';
            };
        };

        return {
            generate: function (ctrl, action, search) {
                if (ctrl == null || action == null)
                    return null;
                else {
                    //add v2 to both url and controller name
                    var ret = '/data/' + ctrl + '/' + action;
                    var s = [];
                    if (search) {
                        //search should be POJO
                        for (var i in search) {
                            s.push(i + '=' + search[i]);
                        }
                    }
                    return ret + (s.length > 0 ? ('?' + s.join('&')) : '');
                }
            },
            langResxUrl: resxUrlGen('Global'),
            langStatusResxUrl: resxUrlGen('Status')
        };
    }]);
})();